package com.example.dninterface;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import com.example.dninterface.bean.ParamBean;
import com.example.dninterface.bean.ResultBean;
import com.example.dninterface.myInterface.Function;
import com.example.dninterface.myInterface.FunctionHasParamHasResult;
import com.example.dninterface.myInterface.FunctionHasParamNoResult;
import com.example.dninterface.myInterface.FunctionManager;
import com.example.dninterface.myInterface.FunctionNoParamHasResult;
import com.example.dninterface.myInterface.FunctionNoParamNoResult;

public class MainActivity extends AppCompatActivity {

    public static final String TAG = "onMain";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        findViewById(R.id.tv_click).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(MainActivity.this, SecondActivity.class);
                startActivity(intent);
            }
        });

        FunctionManager.getInstance().addFunction(new FunctionNoParamNoResult("nn") {
            @Override
            public void function() {
                Log.e(TAG, "nn");
            }
        });
        FunctionManager.getInstance().addFunction(new FunctionHasParamNoResult<ParamBean>("hn") {
            @Override
            public void function(ParamBean o) {
                Log.e(TAG, "hn:" + o.getParam());
            }
        });
        FunctionManager.getInstance().addFunction(new FunctionNoParamHasResult("nh") {
            @Override
            public ResultBean function() {
                Log.e(TAG, "nh:receive");
                ResultBean resultBean = new ResultBean();
                resultBean.setResult("onNH result");
                return resultBean;
            }
        });
        FunctionManager.getInstance().addFunction(new FunctionHasParamHasResult<ParamBean, ResultBean>("hh") {
            @Override
            public ResultBean function(ParamBean o) {
                Log.e(TAG, "hh:" + o.getParam());
                ResultBean resultBean = new ResultBean();
                resultBean.setResult("onHH result");
                return resultBean;
            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
      //  FunctionManager.getInstance().removeFunction("nn");
    }

    @Override
    protected void onStop() {
        super.onStop();
      //  FunctionManager.getInstance().removeFunction("nn");
    }
}
